/* Fesslix - Stochastic Analysis
 * Copyright (C) 2010-2022 Wolfgang Betz
 *
 * Fesslix is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Fesslix is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Fesslix.  If not, see <http://www.gnu.org/licenses/>. 
 */

#ifndef fesslix_flxlibs_H
#define fesslix_flxlibs_H

#include "flxobjects.h"
 

class FlxAddOnManager {
  private:
  public:
    bool rnd;
    bool bayup;
    FlxAddOnManager() : rnd(false), bayup(false) {}
    ~FlxAddOnManager();
    void delete_AddOns();
};


/**
* @brief loads a Fesslix-library
*/
class FlxObjReadLoadLib : public FlxObjReadBase {
  private:
    FlxObjectReadBox* objReadBox;
    
  public:
    FlxObjReadLoadLib(FlxObjectReadBox* objReadBoxV);
    FlxObjBase* read ();
    
    static FlxAddOnManager* AddOnManager;
};

/**
* @brief loads a function from a 'simple' library
*/
class FlxObjReadLoadLibFun : public FlxObjReadBase {
  private:
    FlxObjectReadBox* objReadBox;
    
  public:
    FlxObjReadLoadLibFun(FlxObjectReadBox* objReadBoxV);
    FlxObjBase* read ();
        
};






#endif // fesslix_flxlibs_H